
"""
URL configuration for nms_project_settings project.

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.2/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from drf_yasg import openapi
from django.contrib import admin
from django.urls import path, include
from rest_framework import permissions
from drf_yasg.views import get_schema_view


schema_view = get_schema_view(
    openapi.Info(
        title='NMS Swagger UI',
        default_version='1.0',
        description="NMS APIs",
        contact=openapi.Contact(email='dev@nms_app.in'),
        terms_of_service='-- terms of service',
        Proprietary='dummy',
    ),
    public=True,
    permission_classes=[permissions.AllowAny],
)

urlpatterns = [
    path('admin/', admin.site.urls),
    path('nms_app/', include('nms_app.urls_nms')),
    path('nms_swagger/', schema_view.with_ui('swagger', cache_timeout=0), name='schema-swagger-ui'),
]
